#include "dbusadapter.h"
#include <string>
#include <string.h>

DbusAdapter::DbusAdapter(QObject *parent) : QObject(parent)
{
    QDBusConnection::sessionBus().unregisterService("org.mpris.MediaPlayer2.KylinMusic");
    QDBusConnection::sessionBus().registerService("org.mpris.MediaPlayer2.KylinMusic");
//    QDBusConnection::sessionBus().registerObject("/org/mpris/MediaPlayer2", "org.mpris.MediaPlayer2.Player", this, QDBusConnection::ExportNonScriptableSlots | QDBusConnection::ExportScriptableProperties);
    QDBusConnection::sessionBus().registerObject("/org/mpris/MediaPlayer2", "org.mpris.MediaPlayer2.Player", this, QDBusConnection::ExportAllContents);
    QDBusConnection::sessionBus().registerObject("/org/mpris/MediaPlayer2", "org.mpris.MediaPlayer2", this, QDBusConnection::ExportAllContents);
//    QDBusConnection::sessionBus().registerObject("/org/mpris/MediaPlayer2", "org.mpris.MediaPlayer2.TrackList", this, QDBusConnection::ExportAllContents);
    if(QDBusConnection::sessionBus().registerObject("/org/mpris/MediaPlayer2", "org.freedesktop.DBus.Properties", this, QDBusConnection::ExportAllContents))
       {
            qDebug()<<"成功注册对象org.freedesktop.DBus.Properties";
       }

}

#if UKUI_PANEL_CAN_CONTROL
bool DbusAdapter::getCanControl()
{
    return CanControl;
}
#endif

void DbusAdapter::Stop() const
{
    Widget::mutual->Stop();
}

void DbusAdapter::Next() const
{
    Widget::mutual->Next();
}

void DbusAdapter::Play() const
{
    Widget::mutual->Play();
}

void DbusAdapter::Pause() const
{
    Widget::mutual->Pause();
}


/**
 * @brief DbusAdapter::PlayPause
 * 当华为机器使用有线耳机暂停歌曲播放，其他应用会通过mpris协议调用音乐的PlayPause(播放或暂停）接口。
 *
 * 如果播放已暫停，则恢复播放；
 * 如果播放停止，则开始播放。
 *
 * 系统调用研发负责人： 孙军浩
 */
void DbusAdapter::PlayPause()
{
        qDebug() << "into PlayPause throught mpris.";
    //    emitPropertiesChanged();
        Widget::mutual->PlayPause();
        QVariantMap changedProperties;
        changedProperties.insert("PlaybackStatus",QVariant::fromValue(QDBusVariant(m_playbackStatus)));
        notify("org.mpris.MediaPlayer2.Player",changedProperties,QStringList());
        //qDebug()<<"目前的状态是"<<getState()<<"--"<<PlaybackStatus;

}
void DbusAdapter::notify(const QString &interfaceName, const QVariantMap &changedProperties, const QStringList &invalidatedProperties)
{
    QDBusConnection connection = QDBusConnection::sessionBus();
    QString objectPath = "/org/mpris/MediaPlayer2";
    QDBusMessage signalMessage= QDBusMessage::createSignal(objectPath,"org.freedesktop.DBus.Properties","PropertiesChanged");
//    QVariantMap changed;
//    changed.insert("PlaybackStatus",QVariant(PlaybackStatus));
    signalMessage << interfaceName << changedProperties << invalidatedProperties;
    connection.send(signalMessage);
}

void DbusAdapter::Previous() const
{
    Widget::mutual->Previous();
}

void DbusAdapter::VolumeUp() const
{
    Widget::mutual->VolumeUp();
}

void DbusAdapter::VolumeDown() const
{
    Widget::mutual->VolumeDown();
}

void DbusAdapter::FullScreen() const
{
    Widget::mutual->slotShowMaximized();
}

void DbusAdapter::Exit() const
{
    Widget::mutual->slotClose();
}

#if UKUI_PANEL_CAN_CONTROL
QString DbusAdapter::getState()
{
    return Widget::mutual->getState();
}
#endif
