#ifndef DBUSADAPTER_H
#define DBUSADAPTER_H

#include <QObject>
#include <QDBusConnection>
#include <QtScript/QScriptContext>
//#include "UIControl/player/player.h"
#include "mainwidget.h"

#define UKUI_PANEL_CAN_CONTROL 1

class DbusAdapter : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.mpris.MediaPlayer2.Player")

#if UKUI_PANEL_CAN_CONTROL
    Q_PROPERTY(bool CanControl READ getCanControl)
    Q_PROPERTY(QString PlaybackStatus READ getState)
#endif

public:
    explicit DbusAdapter(QObject *parent = nullptr);

#if UKUI_PANEL_CAN_CONTROL
Q_SIGNALS:
    void PropertiesChanged(const QString &interface_name, const QVariantMap &change_properties, const QStringList &invakudate_properties);
#endif

#if UKUI_PANEL_CAN_CONTROL
private:
    bool CanControl = true; // 任务栏预览图添加属性
    QString m_playbackStatus = "Stopped"; // 任务栏预览图播放/暂停属性

    bool getCanControl();
#endif

public Q_SLOTS:
    // mpris 使用
    void Stop() const;
    void Next() const;
    void Play() const;
    void Pause() const;
    void PlayPause();
    void Previous() const;
    void VolumeUp() const;
    void VolumeDown() const;
    void FullScreen() const;
    void Exit() const;

#if UKUI_PANEL_CAN_CONTROL
    QString getState();
    void notify(const QString &interfaceName, const QVariantMap &changedProperties, const QStringList &invalidatedProperties);

#endif
};

#endif // DBUSADAPTER_H
